<%@ Page Language="VB" debug="true" %>
<%@ import Namespace="System.Security.Cryptography" %>
<%@ import Namespace="System.Text.Encoding" %>

<script language="VB" runat="server">
    Sub Page_Load(ByVal sender As Object, e As System.EventArgs)
        'Chiavi per la criptazione
        'bytIV e bytKey devono essere array di Byte con un certo numero di elementi
        'Per bytIV, per sapere la lunghezza necessaria per un certo algoritmo 
	'consultare la propriet BlockSize e dividere per 8 (per passare da bit a byte)
        'Nel nostro caso (algoritmo DES) ad esempio sarebbe sufficiente 
	'richiamare DES.Create().BlockSize
        Dim bytIV As Byte() = {12, 89, 148, 62, 0, 78, 254, 129}
	Response.Write("IV: { " & ByteArrayString(bytIV) & "}<br>")
        'Per bytKey, per sapere la lunghezza necessaria per un certo algoritmo 
	'consultare la propriet  LegalKeySizes e dividere per 8 (per passare da bit a byte)
        'Nel nostro caso (algoritmo DES) ad esempio sarebbe sufficiente 
	'richiamare DES.Create().LegalKeySizes
        Dim bytKey As Byte() = {122, 56, 201, 34, 100, 22, 200, 103}
	Response.Write("Key: { " & ByteArrayString(bytKey) & "}<br>")
        'In questo caso abbiamo scelto di esplicitare Key e IV ma  
	'anche possibile lasciarne determinare uno casuale all'algoritmo, 
	'che andr poi oppurtunamente salvato e comincato all'utente 
	'( facile ricavarlo dalle propriet Key e IV dell'algoritmo)

        'Stringa di input
        Dim strInput As String
	If Request("str") Is Nothing Then strInput = "ArcadiA Club" Else strInput = Request("str")
	Response.Write("Testo originale: """ & strInput & """<br>")
        'Criptiamo
        Dim bytEncrypted As Byte() = Crypt(strInput, bytIV, bytKey)
	Response.Write("Byte criptati: { " & ByteArrayString(bytEncrypted) & "}<br>")
        'Decriptiamo
        Dim strDecrypted As String = Decrypt(bytEncrypted, bytIV, bytKey)
	Response.Write("Testo originale: """ & strDecrypted & """<br>")
    End Sub

    Function Crypt(ByVal str As String, ByVal bytIV As Byte(), ByVal bytKey As Byte()) As Byte()
        'Creiamo un istanza della classe dell'algoritmo DES
        Dim algDES As DES = DES.Create
        'Creiamo l'oggetto che cripter la stringa fornendogli le chiavi necessarie (IV e Key)
        Dim desEncryptor As ICryptoTransform = algDES.CreateEncryptor(bytIV, bytKey)
        'Dichiariamo le variabili di input e di output
        Dim bytInput() As Byte, bytOutput() As Byte
        'Trasformiamo la stringa in una serie di byte secondo la codifica UTF8
        bytInput = UTF8.GetBytes(str)
        'Effettuiamo la trasformazione sull'intero blocco
        bytOutput = desEncryptor.TransformFinalBlock(bytInput, 0, bytInput.Length)
        'Restituiamo il risultato
        Return bytOutput
    End Function

    Function Decrypt(ByVal bytInput As Byte(), ByVal bytIV As Byte(), ByVal bytKey As Byte()) As String
        'Creiamo un istanza della classe dell'algoritmo DES
        Dim algDES As DES = DES.Create
        'Creiamo l'oggetto che decripter la stringa fornendogli le chiavi necessarie (IV e Key)
        Dim desDecryptor As ICryptoTransform = algDES.CreateDecryptor(bytIV, bytKey)
        'Dichiariamo la variabile di output
        Dim bytOutput() As Byte
        'Effettuiamo la trasformazione sull'intero blocco
        bytOutput = desDecryptor.TransformFinalBlock(bytInput, 0, bytInput.Length)
        'Restituiamo come risultato una stringa ottenuta interpretando 
	'l'output in byte come testo codificato in UTF8
        Return UTF8.GetString(bytOutput)
    End Function

    Function ByteArrayString(ByVal byt As Byte())
        Dim C1 As Integer, str As String = ""
        For C1 = 0 To byt.Length - 1
            str = str & IIf(byt(C1) < 16, "0", "") & Hex(byt(C1)) & " "
        Next C1
	Return str
    End Function
</script>
<form action="des.aspx">
<input type="text" value="Testo da criptare" name="str">
<input type="submit" value="Cripta">
</form>